;----------------------------------------------------------------------
;   
;----------------------------------------------------------------------
#include		"p18f452.inc"
#include		"PDI12.inc"
#include		"Mem.inc"

	ORG 00h
	GOTO	BEGIN

	ORG 08h
	BCF		INTCON, GIEH
	call	INT_MASTER
	retfie

	ORG 18h
	BCF		INTCON, GIEL
	call	INT_SLAW
	retfie

	ORG 28h
BEGIN
;----------------------------------------------------------------------
;  PIC
;----------------------------------------------------------------------
	movlb	0x01	;   

	BCF		INTCON, GIEH ;   
	BCF		INTCON, GIEL ;  
	BSF		RCON, IPEN ;    

	BSF		INTCON3, INT1IE ;   INT1
	BCF		INTCON2, INTEDG1 ;    
	BCF		INTCON3, INT1IP ;  

	BSF		IPR1, ADIP ;    
	BSF		PIE1, ADIE ;     

;  - D- 
	CLRF	TRISA
	CLRF	PORTA
	movlw	B'00000010'
	movwf	TRISB
	CLRF	PORTB
	CLRF	TRISC
	CLRF	PORTC
	CLRF	TRISD
	CLRF	PORTD
	CLRF	TRISE
	CLRF	PORTE

	movlw	B'10000000'
	movwf	ADCON0		
	movlw	B'11000000'
	movwf	ADCON1		

	CLRF	CCP1CON
	CLRF	CCP2CON
	CLRF	T0CON
	CLRF	T1CON
	CLRF	T2CON
	CLRF	T3CON	;  

	clrf	BM_SEND, bsr
	clrf	BM_WRT, bsr
;--------  -------------------------------------------------------

;----------------------------------------------------------------------
; USB
;----------------------------------------------------------------------

	BSF		PORTC, RD 		;  
	BSF		PORTC, RW 		;  

	clrf	EE_Count, bsr;    !!


;----------------------------------------------------------------------
;	  
;----------------------------------------------------------------------

;----------------------------------------------------------------------
; Connect

;   
	movlw	USBCMD_READINT
	call	usb_wrCtr
	call	usb_rdData
	call	usb_rdData
	movlw	USBCMD_RDLASTSTAT0
	call	usb_wrCtr
	call	usb_rdData
	movlw	USBCMD_RDLASTSTAT1
	call	usb_wrCtr
	call	usb_rdData
	movlw	USBCMD_RDLASTSTAT2
	call	usb_wrCtr
	call	usb_rdData
	movlw	USBCMD_RDLASTSTAT3
	call	usb_wrCtr
	call	usb_rdData
	movlw	USBCMD_RDLASTSTAT4
	call	usb_wrCtr
	call	usb_rdData
	movlw	USBCMD_RDLASTSTAT5
	call	usb_wrCtr
	call	usb_rdData

;DConnect - SetMODE
	movlw	USBCMD_SETMODE
	call	usb_wrCtr
	movlw	B'00000110' ;NOLAZYCLOCK|CLOCKRUNNING
	call	usb_wrData
	movlw	B'01000100' ;SETTOONE|CLOCK_9.6M
	call	usb_wrData

;  
	movlw	USBCMD_SETEPSTATUS2
	call	usb_wrCtr
	movlw	B'00000000'
	call	usb_wrData
	movlw	USBCMD_SETEPSTATUS3
	call	usb_wrCtr
	movlw	B'00000000'
	call	usb_wrData
	movlw	USBCMD_SETEPSTATUS4
	call	usb_wrCtr
	movlw	B'00000000'
	call	usb_wrData
	movlw	USBCMD_SETEPSTATUS5
	call	usb_wrCtr
	movlw	B'00000000'
	call	usb_wrData


;SetEnable
	movlw	USBCMD_SETADRESS
	call	usb_wrCtr
	movlw	B'10000000' ;Enable
	call	usb_wrData
	
;SetDMA
	movlw	USBCMD_SETDMA
	call	usb_wrCtr
	movlw	B'11000000'
	call	usb_wrData

;SetMODE
	movlw	USBCMD_SETMODE
	call	usb_wrCtr
	movlw	B'00010110' ;NOLAZYCLOCK|CLOCKRUNNING|SOFTCONNECT
	call	usb_wrData
	movlw	B'01000100' ;SETTOONE|CLOCK_9.6M
	call	usb_wrData

;Set EPENABLE
	movlw	USBCMD_SETENDPOINT
	call	usb_wrCtr
	movlw	B'00000001'
	call	usb_wrData
	
	bsf		PORTB, 3
	
	BSF		INTCON, GIEL ;   
	BSF		INTCON, GIEH ;  
		
;----------------------------------------------------------------------
;   

	SETF	OSC_START, bsr
	
MainLoop
	TSTFSZ	OSC_START, bsr
	GOTO	MainLoop    ;     

	TSTFSZ	BM_BUFCL, bsr
	GOTO	MainLoop    ;     

	movff	A_BM_WRT, A_BM_WRT_T

	;   
	movf	BM_SEND, w, bsr
	CPFSLT	BM_WRT_T, bsr
	goto	bolraw1
	
	setf	temp, bsr
	SUBWF	temp, w, bsr
	ADDWF	BM_WRT_T, w, bsr
	movwf	BM_SEND_SIZE, bsr
	incf	BM_SEND_SIZE, f, bsr
	BRA		ANAL2

bolraw1

	movwf	BM_SEND, bsr
	SUBWF	BM_WRT_T, w, bsr
	movwf	BM_SEND_SIZE, bsr

ANAL2
	movf	BM_MIN, w, bsr			;   
	CPFSGT	BM_SEND_SIZE, bsr
	GOTO	MainLoop	
	
	movf	BM_MAX, w, bsr			;   
	CPFSLT	BM_SEND_SIZE, bsr
	movwf	BM_SEND_SIZE, bsr

	movlw	USBCMD_SETEPSEL5
	call	usb_wrCtr

	movlw	USBCMD_BUFCLEAR
	call	usb_wrCtr

	movlw	USBCMD_RDWR
	call	usb_wrCtr

	movlw	0x00
	call	usb_wrData

	movf	BM_SEND_SIZE, w, bsr
	call	usb_wrData
	
;	movf	BM_SEND_SIZE, w, bsr
;	call	usb_wrData

;	movf	BM_WRT_T, w, bsr
;	call	usb_wrData

	BCF		PORTC, A0 ; 
	CLRF	TRISD

tqq
	movf	POSTINC2, w
	movwf	PORTD
	BCF		PORTC, RW ;  

	INFSNZ	BM_SEND, f, bsr
	LFSR	FSR2, 0x200

	BSF		PORTC, RW

	DECFSZ	BM_SEND_SIZE, f, bsr
	BRA		tqq

	SETF	BM_BUFCL, bsr

	btg		PORTB, 3

	movlw	USBCMD_BUFVALID
	call	usb_wrCtr

	
	goto MainLoop

;

#include		"INTERUP.inc"
#include		"USB Tools.inc"
#include		"USB Control.inc"
#include		"USB Man.inc"
#include		"USB Main.inc"
#include		"Tools.inc"

	END
